SystemOrganization addCategory: #'SUnit-UI'!

HDTestReport subclass: #CommandLineTestRunner
	instanceVariableNames: 'stderr stdout currentTest maxTest shouldSerializeError'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UI'!

!CommandLineTestRunner methodsFor: 'running' stamp: 'abc 10/19/2012 15:45'!
done
	! !

!CommandLineTestRunner methodsFor: 'helper' stamp: 'abc 10/20/2012 13:02'!
handleFailure: anError of: aTestCase 
	self printFailure: anError of: aTestCase.
	self shouldSerializeError 
		ifTrue: [ self serializeError: anError of: aTestCase ]! !

!CommandLineTestRunner methodsFor: 'helper' stamp: 'abc 10/19/2012 15:17'!
increaseTestCount
	currentTest := currentTest + 1.! !

!CommandLineTestRunner methodsFor: 'initialize-release' stamp: 'abc 10/20/2012 13:03'!
initialize
	super initialize.
	shouldSerializeError := false.
	stderr := VTermOutputDriver stderr.
	stdout := VTermOutputDriver stdout.! !

!CommandLineTestRunner methodsFor: 'helper' stamp: 'abc 10/20/2012 13:02'!
printFailure: anError of: aTestCase 
	| errorString testCaseString offset |
	
	errorString := anError printString.
	testCaseString := aTestCase printString.
	
	stdout 
		startOfLine; clearToEnd;
		red; nextPutAll: testCaseString.
	
	"Let's see if we have enough space to print the error"
	offset := 80 - testCaseString size - errorString size.
	offset < 1
		ifTrue: [ stdout right: (80 - 6); nextPutAll: '[FAIL]' ]
		ifFalse: [ stdout right: offset; nextPutAll: errorString ].
		
	stdout
		clear; lf.! !

!CommandLineTestRunner methodsFor: 'printing' stamp: 'abc 10/19/2012 15:26'!
printProgress
	| string |
	string := '[',currentTest asString, '/', maxTest asString,']'.
	stderr startOfLine; right: (80 - string size); nextPutAll: string.! !

!CommandLineTestRunner methodsFor: 'printing' stamp: 'abc 10/19/2012 15:50'!
printReport
	stderr lf; 
		nextPutAll: 'Finished running '; print: maxTest; 
		nextPutAll: ' Test'; nextPutAll: (maxTest = 1 ifTrue: [''] ifFalse: ['s'])! !

!CommandLineTestRunner methodsFor: 'printing' stamp: 'abc 10/19/2012 15:27'!
printTestCase: aTestCase 
	stderr startOfLine; clearToEnd; green; print: aTestCase; clear.
	self printProgress.! !

!CommandLineTestRunner methodsFor: 'running' stamp: 'abc 10/20/2012 13:02'!
runCase: aTestCase
	self increaseTestCount.
	self printTestCase: aTestCase.
	
	[ aTestCase runCase ] 
		on: Halt , Error, TestFailure
		do: [ :err | self handleFailure: err of: aTestCase ]! !

!CommandLineTestRunner methodsFor: 'running' stamp: 'abc 10/19/2012 15:20'!
setUp
	
	currentTest := 0.
	maxTest := suite tests size.! !

!CommandLineTestRunner methodsFor: 'accessing' stamp: 'abc 10/20/2012 13:03'!
shouldSerializeError
	^ shouldSerializeError! !

!CommandLineTestRunner methodsFor: 'accessing' stamp: 'abc 10/20/2012 13:03'!
shouldSerializeError: aBoolean
	shouldSerializeError := aBoolean.! !

!CommandLineTestRunner methodsFor: 'running' stamp: 'abc 10/19/2012 15:36'!
tearDown
	self printReport! !

ProtoObject subclass: #TestCoverage
	instanceVariableNames: 'hasRun reference method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UI'!

!TestCoverage commentStamp: 'LaurentLaffont 4/15/2011 20:19' prior: 0!
I wrap a method in order to detect whether it has been called or not. Then I can be used to calculate test coverage for SUnit.!

!TestCoverage class methodsFor: 'instance creation' stamp: 'lr 3/30/2009 15:23'!
on: aMethodReference
	^ self new initializeOn: aMethodReference! !

!TestCoverage methodsFor: 'private' stamp: 'lr 3/30/2009 20:26'!
doesNotUnderstand: aMessage
	^ method perform: aMessage selector withArguments: aMessage arguments! !

!TestCoverage methodsFor: 'private' stamp: 'StephaneDucasse 8/9/2011 17:51'!
flushCache
	self reference selector flushCache! !

!TestCoverage methodsFor: 'testing' stamp: 'lr 3/30/2009 15:09'!
hasRun
	^ hasRun! !

!TestCoverage methodsFor: 'initialization' stamp: 'lr 3/30/2009 15:19'!
initializeOn: aMethodReference
	hasRun := false.
	reference := aMethodReference.
	method := reference compiledMethod! !

!TestCoverage methodsFor: 'actions' stamp: 'StephaneDucasse 8/9/2011 17:51'!
install
	reference actualClass methodDictionary
		at: reference selector
		put: self! !

!TestCoverage methodsFor: 'private' stamp: 'lr 3/30/2009 15:21'!
mark
	hasRun := true! !

!TestCoverage methodsFor: 'private' stamp: 'lr 3/30/2009 15:27'!
reference
	^ reference! !

!TestCoverage methodsFor: 'evaluation' stamp: 'lr 3/30/2009 15:32'!
run: aSelector with: anArray in: aReceiver
	self mark; uninstall.
	^ aReceiver withArgs: anArray executeMethod: method! !

!TestCoverage methodsFor: 'actions' stamp: 'StephaneDucasse 8/9/2011 17:51'!
uninstall
	reference actualClass methodDictionary
		at: reference selector
		put: method! !

Object subclass: #TestRunner
	instanceVariableNames: 'categories categoriesSelected classes classIndex classesSelected failedList failedSelected errorList errorSelected lastUpdate result previousRun categoryPattern classPattern testAnnouncementBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UI'!

!TestRunner commentStamp: '<historical>' prior: 0!
<lint: #ignore rule: #classNotReferenced rational: 'this view is only accessed from menus'>

!

!TestRunner class methodsFor: 'instance-creation' stamp: 'zork 6/5/2011 12:31'!
open
	^ self new open! !

!TestRunner class methodsFor: 'window color' stamp: 'AlainPlantec 12/16/2009 22:10'!
patchworkUIThemeColor
	"Answer a default color for UI themes that make use of different colors for Browser, MessageList etc..."

	^ Color brown whiter! !

!TestRunner class methodsFor: 'initialization' stamp: 'BartGauquie 11/1/2009 10:52'!
registerAsDefaultTestRunner
	TestRunnerBrowser default: self.! !

!TestRunner methodsFor: 'actions' stamp: 'nice 10/20/2009 21:08'!
addDeclaredPackagesUnderTestTo: packages 
	classesSelected do: 
		[ :class | 
		(class class includesSelector: #packageNamesUnderTest) ifTrue: 
			[ class packageNamesUnderTest do: [ :name | packages add: (PackageInfo named: name) ] ] ]! !

!TestRunner methodsFor: 'actions' stamp: 'StephaneDucasse 8/9/2011 17:51'!
addMethodsUnderTestIn: packages to: methods 
	packages
		do: [:package | package isNil
				ifFalse: [package methods
						do: [:method | ((#(#packageNamesUnderTest #classNamesNotUnderTest ) includes: method selector)
									or: [method compiledMethod isAbstract
											or: [method compiledMethod refersToLiteral: #ignoreForCoverage]])
								ifFalse: [methods add: method]]]]! !

!TestRunner methodsFor: 'accessing' stamp: 'CarloTeixeira 10/24/2011 22:26'!
allSelectedTestSuites
	"Return the suite for all the selected test case classes"
	
	^ classesSelected select: [ :each | each isAbstract not] thenCollect: [:each | each suite].! !

!TestRunner methodsFor: 'factory' stamp: 'lr 10/31/2005 15:31'!
baseClass
	^ TestCase! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'BenjaminVanRyseghem 2/8/2012 17:09'!
browseClass

	^ (classes at: classIndex ifAbsent: [ ^ self ]) browse! !

!TestRunner methodsFor: 'browsing' stamp: 'BenjaminVanRyseghem 1/13/2011 11:31'!
browseSelectedErrorTest

	errorSelected ifNil: [^self].
	self browseSelectedTest: errorSelected! !

!TestRunner methodsFor: 'browsing' stamp: 'BenjaminVanRyseghem 1/13/2011 11:28'!
browseSelectedFailedTest

	failedSelected ifNil: [^self].
	self browseSelectedTest: failedSelected! !

!TestRunner methodsFor: 'browsing' stamp: 'IgorStasenko 4/26/2011 16:21'!
browseSelectedTest: aTest

	Smalltalk tools browser fullOnClass: aTest class selector: aTest selector! !

!TestRunner methodsFor: 'private' stamp: 'lr 3/14/2010 21:13'!
browserEnvironment
	^ Smalltalk globals classNamed: #BrowserEnvironment! !

!TestRunner methodsFor: 'building' stamp: 'CamilloBruni 8/16/2011 02:07'!
build
	"self new build openInWorld"
	
	| window |
	window := (SystemWindow labelled: self label) model: self; extent: self extent.
	
	window addMorph: self buildCategorySearch fullFrame: self categorySearchFrame.
	window addMorph: self buildCategories fullFrame: self categoriesFrame.
	
	window addMorph: self buildClassesSearch fullFrame: self classesSearchFrame.
	window addMorph: self buildClasses fullFrame: self classesFrame.
	
	window	addMorph: self buildStatus fullFrame: self statusFrame. 
	window	addMorph: self buildFailures fullFrame: self failureListFrame. 
	window	addMorph: self buildErrors fullFrame: self errorListFrame. 
	window	addMorph: self buildButtons fullFrame: self buttonsFrame. 
	^ window
	
	
	! !

!TestRunner methodsFor: 'building' stamp: 'md 7/28/2011 13:22'!
buildButtons
	^ PluggablePanelMorph newRow
		model: self;
		layoutInset: 0;
		color: Color transparent;
		addAllMorphs: (self buttons collect: [ :each |
			PluggableButtonMorph new
				on: self
				getState: nil
				action: each second
				label: nil
				menu: nil;
				label: each first;
				setBalloonText: each third;
				getEnabledSelector: (each at: 4);
				hResizing: #spaceFill;
				yourself ]);
		yourself.! !

!TestRunner methodsFor: 'building' stamp: 'StephaneDucasse 9/5/2011 18:23'!
buildCategories

	^ PluggableListMorph new
		on: self
		list: #categoryList 
		primarySelection: #categorySelected 
		changePrimarySelection: #categorySelected: 
		listSelection: #categoryAt: 
		changeListSelection: #categoryAt:put: 
		menu: #categoryMenu:  
		keystroke: nil;
		yourself! !

!TestRunner methodsFor: 'building' stamp: 'CamilloBruni 8/16/2011 02:06'!
buildCategorySearch

	^ SearchMorph new
		model: self;
		updateSelector: #categorySearchUpdate:;
		yourself! !

!TestRunner methodsFor: 'building' stamp: 'StephaneDucasse 9/5/2011 18:23'!
buildClasses

	^ PluggableListMorph new
		on: self
		list: #classList 
		primarySelection: #classSelected 
		changePrimarySelection: #classSelected: 
		listSelection: #classAt: 
		changeListSelection: #classAt:put: 
		menu: #classMenu:  
		keystroke: nil;
		yourself! !

!TestRunner methodsFor: 'building' stamp: 'CamilloBruni 8/16/2011 02:06'!
buildClassesSearch
	
	^ SearchMorph new
		model: self;
		updateSelector: #classSearchUpdate:;
		yourself! !

!TestRunner methodsFor: 'building' stamp: 'StephaneDucasse 6/6/2011 20:38'!
buildErrors
	^ PluggableListMorph new
			on: self 
			list: #errorList
			selected: #errorSelected
			changeSelected: #errorSelected:
			menu: #errorMenu: 
			keystroke: nil.
	! !

!TestRunner methodsFor: 'building' stamp: 'MarcusDenker 6/10/2011 14:11'!
buildFailures
	^ PluggableListMorph new
			on: self 
			list: #failedList
			selected: #failedSelected
			changeSelected: #failedSelected:
			menu: #failureMenu: 
			keystroke: nil.
	
		" do not know how to express
		name: 'Failure List'"! !

!TestRunner methodsFor: 'newbuilding' stamp: 'StephaneDucasse 6/5/2011 15:21'!
buildStatus

	^ (PluggableTextFieldMorph
		on: self 
		text: #statusText 
		accept: nil 
		readSelection: nil 
		menu: #statusMenu:)
			getColorSelector: #statusColor ; yourself.
	! !

!TestRunner methodsFor: 'building' stamp: 'lr 7/27/2011 23:05'!
buttonHeight
	^ self theme buttonMinHeight + 4! !

!TestRunner methodsFor: 'accessing-ui' stamp: 'tbn 7/29/2010 21:17'!
buttons
	^ #(( 'Run Selected' #runAll 'Run all selected tests' #hasRunnable )
		( 'Run Profiled' #runProfiled 'Run tests and profile' #hasRunnable )
		( 'Run Coverage' #runCoverage 'Run test and check code coverage' #hasRunnable )
		( 'Run Failures' #runFailures 'Run all failures' #hasFailures )
		( 'Run Errors' #runErrors 'Run all errors' #hasErrors )
		( 'File out results' #fileOutResults 'File out test results' #hasFailuresOrErrors))! !

!TestRunner methodsFor: 'building' stamp: 'zork 6/5/2011 12:39'!
buttonsFrame
	^LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 1 offset: self buttonHeight negated;
		rightFraction: 1 offset: 0;
		bottomFraction: 1 offset: 0! !

!TestRunner methodsFor: 'building' stamp: 'CamilloBruni 8/16/2011 01:55'!
categoriesFrame
	^LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 0 offset: (UITheme current textFont height + 13);
		rightFraction: 0.25 offset: 0;
		bottomFraction: 1 offset: self buttonHeight negated! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 10/31/2005 15:09'!
categoryAt: anIndex
	^ categoriesSelected includes: (categories at: anIndex ifAbsent: [ ^ false ]).! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 10/31/2005 15:51'!
categoryAt: anInteger put: aBoolean
	categoriesSelected := categoriesSelected
		perform: (aBoolean ifTrue: [ #copyWith: ] ifFalse: [ #copyWithout: ])
		with: (categories at: anInteger ifAbsent: [ ^ self ]).
	self changed: #categorySelected; updateClasses.! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'CamilloBruni 8/16/2011 02:03'!
categoryList
	^ categories! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 11/1/2005 19:25'!
categoryMenu: aMenu
	^ aMenu
		title: 'Categories';
		add: 'Select all' action: #selectAllCategories;
		add: 'Select inversion' action: #selectInverseCategories;
		add: 'Select none' action: #selectNoCategories;
		addLine;
		add: 'Filter...' action: #filterCategories;
		addLine;
		add: 'Refresh' action: #updateCategories;
		yourself.! !

!TestRunner methodsFor: 'building' stamp: 'CamilloBruni 8/16/2011 02:06'!
categorySearchFrame
	^LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 0.25 offset: 0;
		bottomFraction: 0 offset: (UITheme current textFont height + 10)! !

!TestRunner methodsFor: 'building' stamp: 'MarianoMartinezPeck 12/16/2011 11:04'!
categorySearchUpdate: aPattern
	categoryPattern := (aPattern isNil or: [ aPattern trimBoth isEmpty ])
		ifTrue: [ nil ]
		ifFalse: [ aPattern asRegexIgnoringCase ].
	self updateCategories.! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 10/31/2005 15:11'!
categorySelected
	^ 0! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 10/31/2005 15:12'!
categorySelected: anInteger
	self changed: #categorySelected.! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 10/8/2005 19:58'!
classAt: anInteger
	^ classesSelected includes: (classes at: anInteger ifAbsent: [ ^ false ]).! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 11/21/2005 13:19'!
classAt: anInteger put: aBoolean
	classesSelected := classesSelected
		perform: (aBoolean ifTrue: [ #copyWith: ] ifFalse: [ #copyWithout: ])
		with: (classes at: anInteger ifAbsent: [ ^ self ]).
	self changed: #classSelected; changed: #hasRunnable.! !

!TestRunner methodsFor: 'factory' stamp: 'StephaneDucasse 6/9/2012 23:05'!
classForTestSuite
	^ TestSuite! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'nice 1/5/2010 15:59'!
classList
	| offset |
	classes isEmpty ifTrue: [ ^ classes ].
	offset := classes first allSuperclasses size.
	^ classes collect: [ :each | | ident |
		ident := String 
			new: 2 * (0 max: each allSuperclasses size - offset) 
			withAll: $ .
		each isAbstract
			ifFalse: [ ident , each name ]
			ifTrue: [ 
				ident asText , each name asText 
					addAttribute: TextEmphasis italic;
					yourself ] ].! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'StephaneDucasse 5/15/2011 22:42'!
classMenu: aMenu
	^ aMenu
		title: 'Classes';
		add: 'Browse' action: #browseClass;
		addLine;
		add: 'Select all' action: #selectAllClasses;
		add: 'Select unit tests' action: #selectAllUnitTests;
		add: 'Select subclasses' action: #selectSubclasses;
		add: 'Select inversion' action: #selectInverseClasses;
		add: 'Select none' action: #selectNoClasses;
		add: 'Refresh' action: #updateClasses;
		addLine;
		add: 'Filter...' action: #filterClasses;
		addLine;
		add: 'Run selected' action: #runAll;
		yourself.! !

!TestRunner methodsFor: 'building' stamp: 'MarianoMartinezPeck 12/16/2011 11:04'!
classSearchUpdate: aPattern
	classPattern := (aPattern isNil or: [ aPattern trimBoth isEmpty ])
		ifTrue: [ nil ]
		ifFalse: [ aPattern asRegexIgnoringCase ].
	self updateClasses.! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 1/20/2009 14:46'!
classSelected
	^ classIndex! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 1/20/2009 14:48'!
classSelected: anInteger
	classIndex := anInteger.
	self changed: #classSelected! !

!TestRunner methodsFor: 'building' stamp: 'CamilloBruni 8/16/2011 01:55'!
classesFrame
	^LayoutFrame new
		leftFraction: 0.25 offset: 0;
		topFraction: 0 offset: (UITheme current textFont height + 13);
		rightFraction: 0.5 offset: 0;
		bottomFraction: 1 offset: self buttonHeight negated! !

!TestRunner methodsFor: 'building' stamp: 'StephaneDucasse 9/5/2011 18:37'!
classesSearchFrame
	^LayoutFrame new
		leftFraction: 0.25 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 0.5 offset: 0;
		bottomFraction: 0 offset: (StandardFonts defaultFont height + 10)! !

!TestRunner methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 11/1/2011 07:44'!
collectCoverageFor: methods
	| wrappers suite |
	wrappers := methods collect: [ :each | TestCoverage on: each ].
	suite := self
		resetResult;
		suiteForAllSelected.
	
	[ wrappers do: [ :each | each install ].
	[ self runSuite: suite ] ensure: [ wrappers do: [ :each | each uninstall ] ] ] valueUnpreemptively.
	wrappers := wrappers reject: [ :each | each hasRun ].
	wrappers isEmpty 
		ifTrue: 
			[ UIManager default inform: 'Congratulations. Your tests cover all code under analysis.' ]
		ifFalse: 
			[ 
			| ml |
			ml := MessageList new.
			(wrappers collect: [ :each | ml addMethodReference: each reference ]).
			(Smalltalk tools messageList 
				on: ml
				named: 'Not Covered Code (' , (100 - (100 * wrappers size // methods size)) printString , '% Code Coverage)') open ].
	self saveResultInHistory! !

!TestRunner methodsFor: 'actions' stamp: 'StephaneDucasse 6/9/2012 23:10'!
debug: aTestCase
	self
		debugSuite:
			(self classForTestSuite new
				addTest: aTestCase;
				yourself)! !

!TestRunner methodsFor: 'actions' stamp: 'SantiagoBragagnolo 4/29/2012 20:25'!
debugSuite: aTestSuite
	self executeSuite: aTestSuite as: [ :aSuite | aSuite debug ].! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/8/2005 22:37'!
errorList
	^ errorList collect: [ :each | each printString ].! !

!TestRunner methodsFor: 'building' stamp: 'lr 7/27/2011 23:00'!
errorListFrame
	^LayoutFrame new
		leftFraction: 0.5 offset: 0;
		topFraction: 0.5 offset: 0;
		rightFraction: 1 offset: 0;
		bottomFraction: 1 offset: self buttonHeight negated! !

!TestRunner methodsFor: 'accessing-menu' stamp: 'BenjaminVanRyseghem 1/13/2011 11:35'!
errorMenu: aMenu
	"Add the browse item only if an item is selected"

	self statusMenu: aMenu.
	errorSelected ifNotNil: [aMenu add: 'Browse test' action: #browseSelectedErrorTest].
	^aMenu! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/6/2005 19:46'!
errorSelected
	^ errorList indexOf: errorSelected.! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/27/2005 10:37'!
errorSelected: anInteger
	errorSelected := errorList at: anInteger ifAbsent: nil.
	self changed: #errorSelected.
	errorSelected ifNotNil: [ self debug: errorSelected ].! !

!TestRunner methodsFor: 'accessing' stamp: 'StephaneDucasse 6/9/2012 23:05'!
errorTestSuites
	^ errorList
		collect: [ :each | 
			self classForTestSuite new
				in: [ :suite | 
							suite
								addTest: each;
								name: (self label: 'Error' forSuite: suite) ];
				yourself ]! !

!TestRunner methodsFor: 'actions' stamp: 'lr 3/14/2010 21:13'!
excludeClassesNotUnderTestFrom: methods
	classesSelected
		do: [ :class | 
			(class class includesSelector: #classNamesNotUnderTest)
				ifTrue: [ 
					class classNamesNotUnderTest
						do: [ :className | 
							| theClass |
							theClass := Smalltalk globals classNamed: className.
							theClass
								ifNotNil: [ 
									theClass methods do: [ :each | methods remove: each methodReference ifAbsent: [  ] ].
									theClass class methods do: [ :each | methods remove: each methodReference ifAbsent: [  ] ] ] ] ] ]! !

!TestRunner methodsFor: 'processing' stamp: 'SantiagoBragagnolo 4/30/2012 14:25'!
executeSuite: aTestSuite as: aBlock
" The block defines how to interact with the suite. run with a result or debug "
	aTestSuite subscribe:TestAnnouncement do: self updateUIBlock.
	[ aBlock cull: aTestSuite cull: result  ] ensure: [
		aTestSuite unsubscribe:TestAnnouncement.
	].


! !

!TestRunner methodsFor: 'accessing-ui' stamp: 'lr 10/8/2005 18:39'!
extent
	^ 640 @ 480! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/8/2005 22:37'!
failedList
	^ failedList collect: [ :each | each printString ].! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/6/2005 19:47'!
failedSelected
	^ failedList indexOf: failedSelected.! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/6/2005 20:14'!
failedSelected: anInteger
	failedSelected := failedList at: anInteger ifAbsent: nil.
	self changed: #failedSelected.
	failedSelected ifNotNil: [ self debug: failedSelected ].! !

!TestRunner methodsFor: 'building' stamp: 'bp 11/22/2010 20:43'!
failureListFrame
	^LayoutFrame new
		leftFraction: 0.5 offset: 0;
		topFraction: 0 offset: self statusHeight;
		rightFraction: 1 offset: 0;
		bottomFraction: 0.5 offset: 0! !

!TestRunner methodsFor: 'accessing-menu' stamp: 'BenjaminVanRyseghem 1/13/2011 11:35'!
failureMenu: aMenu
	"Add the browse item only if an item is selected"
	
	failedSelected ifNotNil: [aMenu add: 'Browse test' action: #browseSelectedFailedTest].
	^ aMenu! !

!TestRunner methodsFor: 'accessing' stamp: 'StephaneDucasse 6/9/2012 23:05'!
failureTestSuites
	^ failedList
		collect: [ :each | 
			self classForTestSuite new
				in: [ :suite | 
							suite
								addTest: each;
								name: (self label: 'Failure' forSuite: suite) ];
				yourself ]! !

!TestRunner methodsFor: 'actions' stamp: 'MarcusDenker 5/1/2011 14:03'!
fileOutResults
	| fileName defaultFilename stream printer |
	"Save current test results into text file."
	"Generate a filename like 'tests_Pharo-1.1-11367-Beta_23_May_2010_9:19:20_am.txt' "
	defaultFilename := 	'tests_',
						SystemVersion current version, 
						'_', 
						(result timeStamp asString copyReplaceAll: ' ' with: '_'),
						'.txt'.
	fileName := UIManager default 
		request: 'Enter the file name' 
		initialAnswer: defaultFilename.
	
	stream := MultiByteFileStream newFileNamed: fileName.	
	[result fileOutOn: stream] 
		ensure: [stream close].! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 7/4/2009 15:08'!
filterCategories
	| pattern |
	pattern := UIManager default 
		request: 'Pattern to select categories:' 
		initialAnswer: '*'.
	pattern isNil ifTrue: [ ^ self ].
	categoriesSelected := (categories 
		select: [ :each | pattern match: each ]) asSet.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 7/4/2009 15:10'!
filterClasses
	| pattern |
	pattern := UIManager default 
		request: 'Pattern to select tests:' 
		initialAnswer: '*'.
	pattern isNil ifTrue: [ ^ self ].
	classesSelected := (classes select: [ :each | 
		pattern match: each name ]) asSet.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'utilities' stamp: 'CamilloBruni 8/16/2011 02:05'!
findCategories
	| visible |
	visible := Set new.
	self baseClass withAllSubclassesDo: [ :each |
		each category ifNotNil: [ :category |
			visible add: category ] ].
	^ Array streamContents: [ :stream |
		Smalltalk organization categories do: [ :each |
			((visible includes: each) 
					and: [ categoryPattern isNil or: [ (categoryPattern matchesIn: each) isEmpty not]])
				ifTrue: [ stream nextPut: each ] ] ].! !

!TestRunner methodsFor: 'utilities' stamp: 'CamilloBruni 8/16/2011 02:11'!
findClassesForCategories: aCollection
	| items |
	aCollection isEmpty
		ifTrue: [ ^ self baseClass withAllSubclasses asSet ].
	items := aCollection
		gather: [ :category | 
			((Smalltalk organization listAtCategoryNamed: category) 
				collect: [ :each | Smalltalk globals at: each ])
				select: [ :each | each includesBehavior: self baseClass ] ].

	^ items asSet! !

!TestRunner methodsFor: 'testing' stamp: 'lr 11/21/2005 13:19'!
hasErrors
	^ result hasErrors.! !

!TestRunner methodsFor: 'testing' stamp: 'lr 11/21/2005 13:19'!
hasFailures
	^ result hasFailures.! !

!TestRunner methodsFor: 'testing' stamp: 'LaurentLaffont 5/23/2010 08:19'!
hasFailuresOrErrors
	^ result hasFailures | result hasErrors.! !

!TestRunner methodsFor: 'history saving' stamp: 'simon.denier 11/13/2008 20:28'!
hasProgress

	result classesTested do: [:cls |
		(cls class methodDictionary includesKey: #lastStoredRun)
			ifTrue: [^ true]].
	^ false! !

!TestRunner methodsFor: 'history saving' stamp: 'GwenaelCasaccio 10/1/2008 22:00'!
hasResults

	^ result notNil! !

!TestRunner methodsFor: 'testing' stamp: 'lr 11/21/2005 13:19'!
hasRunnable
	^ classesSelected notEmpty.! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/1/2008 12:00'!
historyMenuList
	^ {'** save current result **'}, (self previousRun collect: [:ts | ts printString])! !

!TestRunner methodsFor: 'initialization' stamp: 'EstebanLorenzano 8/3/2012 14:30'!
initialize
	super initialize.
	failedList := errorList := Array new.
	SystemAnnouncer uniqueInstance weak
		on: ClassAdded, CategoryAdded, ClassRemoved, CategoryRemoved, ClassRenamed, CategoryRenamed, ClassRecategorized 
			send: #update 
			to: self.
	self update; resetResult! !

!TestRunner methodsFor: 'accessing-ui' stamp: 'lr 1/20/2006 13:36'!
label
	^ 'Test Runner' ! !

!TestRunner methodsFor: 'private' stamp: 'lr 10/27/2005 10:32'!
label: aString forSuite: aTestSuite
	^ String streamContents: [ :stream |
		stream nextPutAll: 'Running '; print: aTestSuite tests size; space; nextPutAll: aString.
		aTestSuite tests size > 1 ifTrue: [ stream nextPut: $s ] ]. ! !

!TestRunner methodsFor: 'building' stamp: 'zork 6/5/2011 12:31'!
open

	^ self build openInWorld
	
! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/1/2008 11:46'!
previousRun

	^ previousRun ifNil: [ previousRun := OrderedCollection new ]! !

!TestRunner methodsFor: 'actions' stamp: 'onierstrasz 5/14/2009 14:11'!
promptForPackages
	| packages |
	packages := (PackageOrganizer default packages
				reject: [:package | (package packageName beginsWith: 'Kernel')
						or: [(package packageName beginsWith: 'Collections')
								or: [(package packageName beginsWith: 'Exceptions')
										or: [(package packageName beginsWith: 'SUnit')
												or: [(package packageName beginsWith: 'System')
														or: [package packageName includesSubstring: 'Test' caseSensitive: false]]]]]])
				sort: [:a :b | a packageName < b packageName].
	packages := Array
				with: (UIManager default
						chooseFrom: (packages
								collect: [:package | package packageName])
						values: packages
						title: 'Select Package').
	^ packages! !

!TestRunner methodsFor: 'actions' stamp: 'StephaneDucasse 6/9/2012 22:49'!
resetResult

	self result: TestAsserter classForTestResult new ; updateResults.! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/6/2005 15:47'!
result
	^ result! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/8/2005 22:47'!
result: aResult
	result := aResult! !

!TestRunner methodsFor: 'actions' stamp: 'CarloTeixeira 10/24/2011 22:26'!
runAll

	self resetResult.
	self runTestSuites: self allSelectedTestSuites.
	self saveResultInHistory! !

!TestRunner methodsFor: 'actions' stamp: 'onierstrasz 5/14/2009 14:15'!
runCoverage
	| packages methods |
	packages := Set new.
	self addDeclaredPackagesUnderTestTo: packages.
	packages isEmpty ifTrue: 
		[ packages := self promptForPackages ].
	methods := OrderedCollection new.
	self 
		addMethodsUnderTestIn: packages
		to: methods.
	self excludeClassesNotUnderTestFrom: methods.
	methods isEmpty ifTrue: 
		[ ^ UIManager default inform: 'No methods found for coverage analysis.' ].
	self collectCoverageFor: methods
! !

!TestRunner methodsFor: 'actions' stamp: 'CarloTeixeira 10/24/2011 22:26'!
runErrors
	self result instVarNamed: 'errors' put: OrderedCollection new.
	self runTestSuites: self errorTestSuites.! !

!TestRunner methodsFor: 'actions' stamp: 'CarloTeixeira 10/24/2011 22:26'!
runFailures
	self result instVarNamed: 'failures' put: Set new.
	self runTestSuites: self failureTestSuites.! !

!TestRunner methodsFor: 'actions' stamp: 'lr 10/31/2005 17:13'!
runProfiled
	MessageTally spyOn: [ self runAll ].! !

!TestRunner methodsFor: 'actions' stamp: 'SantiagoBragagnolo 4/29/2012 20:25'!
runSuite: aTestSuite
	self executeSuite: aTestSuite as: [ :aSuite :aResult | aSuite run: aResult ].
	self updateResults

! !

!TestRunner methodsFor: 'actions' stamp: 'lr 11/3/2005 09:15'!
runTest: aTestCase
	aTestCase run: result.
	self updateStatus: true.! !

!TestRunner methodsFor: 'actions' stamp: 'CarloTeixeira 10/24/2011 22:30'!
runTestSuites: testSuites 
	testSuites
		do: [:testSuite | self runSuite: testSuite]
		displayingProgress: 'Running Tests'! !

!TestRunner methodsFor: 'history saving' stamp: 'simon.denier 11/13/2008 19:36'!
saveResultInHistory
	result dispatchResultsIntoHistory! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 7/4/2009 15:08'!
selectAllCategories
	categoriesSelected := categories asSet.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'gvc 7/24/2007 12:01'!
selectAllClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := classes asSet.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'JorgeRessia 3/16/2010 20:24'!
selectAllUnitTests
	classesSelected := classes asSet select: [ :eachClass | eachClass isUnitTest ].
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 7/4/2009 15:08'!
selectInverseCategories
	categoriesSelected := categories asSet 
		removeAll: categoriesSelected;
		yourself.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'gvc 7/24/2007 12:01'!
selectInverseClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := classes asSet 
		removeAll: classesSelected;
		yourself.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 7/4/2009 15:08'!
selectNoCategories
	categoriesSelected := Set new.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'gvc 7/24/2007 11:59'!
selectNoClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := Set new.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'gvc 7/24/2007 12:01'!
selectSubclasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	| classesForPackages |
	classesForPackages := self findClassesForCategories: categoriesSelected.	
	classesSelected := (classesSelected gather: [ :class |
		class withAllSubclasses select: [ :each |
			classesForPackages includes: each ] ])
		asSet.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'history saving' stamp: 'IgorStasenko 4/26/2011 16:21'!
showDiffWith: aTestResult
	| string diff |

	diff := result diff: aTestResult.
	string := String streamContents: [:str|
		str nextPutAll: '----------------'; cr.
		str nextPutAll: 'Diff between current result with: ', aTestResult asString; cr.
		str nextPutAll: 'New passed: '.
		diff first do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		str nextPutAll: 'New failures: '.
		diff second do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		
		str nextPutAll: 'New errors: '.
		diff third do: [:s| str nextPutAll: s printString, ' '].
		str cr].
	
	Smalltalk tools workspace new contents: string; openLabel: 'SUnit Progress'
	! !

!TestRunner methodsFor: 'history saving' stamp: 'stephane.ducasse 10/12/2008 19:24'!
showHistoryMenu
	| selectionIndex selectedPreviousResult actionIndex |
	selectionIndex := UIManager default chooseFrom: self historyMenuList title: 'History:'.

	"We pressed outside the menu"
	selectionIndex isZero ifTrue: [ ^ self ]. 				

	"save current result is selected"
	selectionIndex = 1 ifTrue: [ self previousRun addFirst: result. ^ self ]. 			

	selectedPreviousResult := self previousRun at: (selectionIndex - 1).
 	actionIndex := (UIManager default chooseFrom: #('delete' 'show diff')  title:  'Action:').
	actionIndex = 1 ifTrue: [ self previousRun remove: selectedPreviousResult. ^ self ].
	actionIndex = 2 ifTrue: [ self showDiffWith: selectedPreviousResult].	! !

!TestRunner methodsFor: 'history saving' stamp: 'MarcusDenker 5/27/2011 14:11'!
showProgress
	| testCaseClasses d string |
	testCaseClasses := (self suiteForAllSelected tests collect: [:testCase | testCase class]) asSet.
	
	"At the end of the algorithm, d will contains all the diff between what was saved and the current result"
	d := Dictionary new.
	d at: #passed put: OrderedCollection new.
	d at: #failures put: OrderedCollection new.
	d at: #errors put: OrderedCollection new.

	testCaseClasses do: [ :cls | | t |
		(cls class methodDict includesKey: #lastStoredRun)
			ifTrue: [t := cls lastStoredRun.
					(t at: #passed) do: [:s | 	
											(result isErrorFor: cls selector: s)
												ifTrue: [(d at: #errors) add: {cls . s}].
											(result isFailureFor: cls selector: s)
												ifTrue: [(d at: #failures) add: {cls . s}]  ].
											
					(t at: #failures) do: [:s | (result isPassedFor: cls selector: s)
												ifTrue: [(d at: #passed) add: {cls . s}].
											(result isErrorFor: cls selector: s)
												ifTrue: [(d at: #errors) add: {cls . s}]].
											
					(t at: #errors) do: [:s | 	(result isPassedFor: cls selector: s)
												ifTrue: [(d at: #passed) add: {cls . s}].
											(result isFailureFor: cls selector: s)
												ifTrue: [(d at: #failures) add: {cls . s}]]]].
		
			
	string := String streamContents: [:str|
		str nextPutAll: '----------------'; cr.
		str nextPutAll: 'Diff between current result and saved result'; cr.
		str nextPutAll: 'New passed: '.
		(d at: #passed) do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		str nextPutAll: 'New failures: '.
		(d at: #failures) do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		
		str nextPutAll: 'New errors: '.
		(d at: #errors) do: [:s| str nextPutAll: s printString, ' '].
		str cr].
	
	Smalltalk tools workspace new contents: string; openLabel: 'SUnit Progress' string.

	! !

!TestRunner methodsFor: 'utilities' stamp: 'lr 10/10/2005 08:43'!
sortClass: aFirstClass before: aSecondClass
	| first second |
	first := aFirstClass withAllSuperclasses reversed.
	second := aSecondClass withAllSuperclasses reversed.
	1 to: (first size min: second size) do: [ :index | 
		(first at: index) == (second at: index)
			ifFalse: [ ^ (first at: index) name <= (second at: index) name ] ].
	^ second includes: aFirstClass.! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 3/16/2010 19:37'!
statusColor
	result hasErrors 
		ifTrue: [ ^ Color red ].
	result hasFailures 
		ifTrue: [ ^ Color yellow ].
	^ Color green! !

!TestRunner methodsFor: 'building' stamp: 'bp 11/22/2010 20:41'!
statusFrame
	^LayoutFrame new
		leftFraction: 0.5 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 1 offset: 0;
		bottomFraction: 0 offset: self statusHeight! !

!TestRunner methodsFor: 'building' stamp: 'lr 7/27/2011 23:01'!
statusHeight
	^ self theme textFont height * 4! !

!TestRunner methodsFor: 'accessing-menu' stamp: 'simon.denier 11/13/2008 19:43'!
statusMenu: aMenu
	^ aMenu
		add: 'History' action: #showHistoryMenu;
		add: 'Store result as progress reference' action: #storeResultIntoTestCases;
		add: 'Show progress' action: #showProgress; 
		yourself! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/8/2005 22:45'!
statusText
	^ result printString.! !

!TestRunner methodsFor: 'history saving' stamp: 'simon.denier 11/13/2008 20:28'!
storeResultIntoTestCases

	result classesTested do: [:testCaseCls | testCaseCls generateLastStoredRunMethod ]
! !

!TestRunner methodsFor: 'accessing' stamp: 'StephaneDucasse 6/9/2012 23:05'!
suiteForAllSelected
	"Return the suite for all the selected test case classes"

	^ self classForTestSuite new
		in: [ :suite | 
			classesSelected
				do: [ :each | 
					each isAbstract
						ifFalse: [ each addToSuiteFromSelectors: suite ] ].
			suite name: (self label: 'Test' forSuite: suite) ]! !

!TestRunner methodsFor: 'theme' stamp: 'MarcusDenker 4/14/2011 13:14'!
theme
	"Answer the ui theme that provides controls."

	^UITheme current! !

!TestRunner methodsFor: 'updating' stamp: 'lr 3/22/2006 19:35'!
update
	self updateCategories; updateClasses! !

!TestRunner methodsFor: 'updating' stamp: 'lr 10/31/2005 15:45'!
updateCategories
	categories := self findCategories.
	categoriesSelected := categoriesSelected isNil
		ifTrue: [ Set new ]
		ifFalse: [
			categoriesSelected
				select: [ :each | categories includes: each ] ].
	self changed: #categoryList; changed: #categorySelected.! !

!TestRunner methodsFor: 'updating' stamp: 'CamilloBruni 8/16/2011 02:11'!
updateClasses
	| classesForCategories |
	classesForCategories := self findClassesForCategories: categoriesSelected.
	
	classPattern ifNotNil: [
		classesForCategories := classesForCategories reject: [:cls| (classPattern matchesIn: cls name) isEmpty ]].
	
	classes := classesForCategories asArray
		sort: [ :a :b | self sortClass: a before: b ].
	classIndex := 0.
	classesSelected := classesSelected isNil
		ifTrue: [ classesForCategories ]
		ifFalse: [ 
			classesSelected
				select: [ :each | classesForCategories includes: each ] ].
	self changed: #classList; 
		changed: #classSelected; 
		changed: #hasRunnable.! !

!TestRunner methodsFor: 'updating' stamp: 'LaurentLaffont 2/27/2011 17:20'!
updateResults
	"<lint: #expect rule: #guardingClause>"
	"<lint: #expect rule: #longMethods>"

	self updateStatus: false.
	failedList size = result failures size ifFalse: [
		failedList := result failures asArray
			sort: [ :a :b | a printString <= b printString ].
		failedSelected := nil.
		self 
			changed: #failedList; 
			changed: #failedSelected;
			changed: #hasFailures;
			changed: #hasProgress;
			changed: #hasFailuresOrErrors  ].
	errorList size = result errors size ifFalse: [
		errorList := result errors asArray
			sort: [ :a :b | a printString <= b printString ].
		errorSelected := nil.
		self 
			changed: #errorList; 
			changed: #errorSelected;
			changed: #hasErrors;
			changed: #hasProgress;
			changed: #hasFailuresOrErrors  ].! !

!TestRunner methodsFor: 'updating' stamp: 'lr 11/3/2005 09:28'!
updateStatus: aBoolean
	"Update the status display, at most once a second if aBoolean is true."

	(aBoolean and: [ lastUpdate = Time totalSeconds ])
		ifTrue: [ ^ self ].
	self changed: #statusText; changed: #statusColor.
	lastUpdate := Time totalSeconds.! !

!TestRunner methodsFor: 'updating' stamp: 'SeanDeNigris 6/21/2012 12:33'!
updateUIBlock
	^ testAnnouncementBlock ifNil: [
		testAnnouncementBlock :=  [ :announcement | self updateStatus: true ] ].! !

!TestRunner methodsFor: 'private' stamp: 'CamilleTeruel 7/29/2012 18:49'!
windowIsClosing
	SystemAnnouncer uniqueInstance unsubscribe: self! !
